/* GCC */

#include <algorithm>
#include <fstream>
#include <sstream>
#include <vector>
#include <list>

using namespace std;

const int day = 1440;

struct Link
{
    int vertex;
    int departTime;
    int arriveTime;
    int cost;
    Link() {}
    Link(int v,int d,int a,int c)
    {
        vertex = v;
        departTime = d;
        arriveTime = a;
        cost = c;
    }
    operator int()
    {
        return vertex;
    }
};

void updateState(std::list<std::pair<int,int> >& state,std::pair<int,int> pushed)
{
    for(std::list<std::pair<int,int> >::iterator i = state.begin();i != state.end();i++)
        if((i->first <= pushed.first) && (i->second <= pushed.second))
            return;
    for(std::list<std::pair<int,int> >::iterator i = state.begin();i != state.end();)
    {
        if((i->first >= pushed.first) && (i->second >= pushed.second))
            i = state.erase(i);
        else
            i++;
    }
    state.push_back(pushed);
}

int main()
{
    std::ifstream in("tax.in");
    std::ofstream out("tax.out");
    int n,m,t,start,finish;
    in >> n >> m >> t >> start >> finish;
    in.get();
    std::vector<std::vector<Link> > graph(n);
    int number,cost;
    int departTime,arriveTime;
    int previous = -1;
    for(int i = 0;i < m;i++)
    {
        std::string line;
        std::getline(in,line);
        std::istringstream input(line);
        while(input >> number >> arriveTime >> cost)
        {
            if(previous != -1)
                graph[previous].push_back(Link(number-1,departTime,arriveTime,cost));
            previous = number-1;
            departTime = arriveTime;
        }
    }
    in.close();
    std::vector<std::list<std::pair<int,int> > > state(graph.size());
    state[start-1].push_back(std::make_pair(0,0));
    for(int _ = 0;_ < graph.size();_++)
    {
        for(int i = 0;i < graph.size();i++)
        {
            for(int j = 0;j < graph[i].size();j++)
            {
                for(std::list<std::pair<int,int> >::iterator k = state[i].begin();k != state[i].end();k++)
                {
                    int currentTime = k->first;
                    int currentCost = k->second + graph[i][j].cost;
                    if(currentTime % day > graph[i][j].departTime)
                        currentTime = (currentTime / day + 1)*day;
                    currentTime = (currentTime / day)*day + graph[i][j].arriveTime;
                    updateState(state[graph[i][j]],std::make_pair(currentTime,currentCost));
                }
            }
        }
    }
    std::vector<std::pair<int,int> > answer;
    for(std::list<std::pair<int,int> >::iterator i = state[finish-1].begin();i != state[finish-1].end();i++)
        answer.push_back(*i);
    std::sort(answer.begin(),answer.end());
    out << answer[0].first << ' ' << answer[0].second << std::endl
        << answer[1].first << ' ' << answer[1].second << std::endl;
    out.close();
}
